# -*- coding: cp1252 -*-
#Need install pyinstaller
#Ma telecommande samsung: Touche C: 3772819543 Touche D: 3772803223

from socket import *
from uuid import getnode as get_mac
import time
import subprocess
import sys
import time

class WolAndShut:
    """ Classe pour gerer le shutdown a distance depuis l'arduino, sans configuration manuelle des adresses ip et mac """
    """ On envoi notre adresse mac a l'arduino avant de pouvoir activer le wakeOnLan """
    """ Si on lance le script avec le param firstboot alors on reecrit la mac vers l'arduino """
    
    def __init__(self):
        self.broadcast = "255.255.255.255"
        self.myIP = ""
        self.myMac = ""
        self.arduinoIP = ""
        self.arduinoPort = 5001
        self.udpPortServer = 5003

    def createSocket(self):
        s = socket(AF_INET, SOCK_DGRAM)
        return s

    def envoiMac(self):
        s = self.createSocket()
        s.connect((self.broadcast, self.arduinoPort))
        if self.myMac is not None: 
            s.send(self.myMac)
        s.close()
        
    def socketRecept(self):
        s = self.createSocket()
        s.bind(("", self.udpPortServer))
        s.settimeout(1)
        return s

    def receptData(self, s):
        try:
            data, addr = s.recvfrom(1024) #buffer size is 1024 bytes
            return data
        except:
            pass
        return None

    def shutdownPC(self):
        try:
            subprocess.call(["shutdown", "-f", "-s", "-t", "30"])
        except:
            pass
        
if __name__ == '__main__':
    #
    shut = WolAndShut()
   
    try:
        time.sleep(30)
        tmp = iter('%012x' % get_mac())
        shut.myMac = ':'.join(a+b for a,b in zip(tmp, tmp))
        #print "Addresses sent to arduino"
        shut.envoiMac()
        #print "Running..."
        socR = shut.socketRecept()
        while(1):
            try:
                data = shut.receptData(socR)
                
                if "shutdown" in data:
                    #print data
                    shut.shutdownPC()
                elif "yourmac?" in data:
                    #print data
                    #print "Addresses sent to arduino"
                    shut.envoiMac()
                else:
                    pass
                    #print "Unknown message"
            except:
                pass
    except:
        pass
